package com.younike.system.domain.vo;

import com.younike.system.domain.Order;
import lombok.Data;

import java.math.BigDecimal;

/**
 * 会员订单详情对象
 *
 * @author dail
 * @date 2022-01-11
 */
@Data
public class MemberOrderDetailVo extends Order {

    private static final long serialVersionUID = 1L;

    /**
     * 商品id
     */
    private Long goodsId;

    /**
     * 商品名称
     */
    private String goodsName;

    /**
     * 商品单位
     */
    private String goodsUnit;

    /**
     * 商品单位名称
     */
    private String goodsUnitName;

    /**
     * 订单状态名称
     */
    private String orderStateName;

    /**
     * 服务人员头像
     */
    private String serverAvatar;

    /**
     * 服务人员id
     */
    private Long serverId;

    /**
     * 服务人员名称
     */
    private String serverName;

    /**
     * 家政等级
     */
    private String serverLevel;

    /**
     * 家政等级名称
     */
    private String serverLevelName;

    /**
     * 好评率（4分及以上为好评）
     */
    private BigDecimal rate;

    /**
     * 工龄
     */
    private Integer serverAge;

    /**
     * 服务地址详情
     */
    private String address;

    /**
     * 门牌号
     */
    private String detailed;

    /**
     * 会员名称
     */
    private String memberName;

    /**
     * 会员手机号
     */
    private String phone;

    /**
     * 商品服务人员单价
     */
    private BigDecimal goodsServerPrice;

    /**
     * 商品数量
     */
    private Integer goodsCounts;

    /**
     * 追加服务数量
     */
    private String addCounts;

    /**
     * 服务类别id
     */
    private Long cateId;

    /**
     * 服务类别名称
     */
    private String cateName;

    /**
     * 父级服务类别名称
     */
    private String parentCateName;

    /**
     * 退款状态
     */
    private String refundState;

    /**
     * 退款状态名称
     */
    private String refundStateName;

    /**
     * 申请退款金额
     */
    private BigDecimal payMoney;

    /**
     * 实际退款金额
     */
    private BigDecimal refundMoney;

    /**
     * 申请退款原因
     */
    private String refundReason;

    /**
     * 商户电话
     */
    private String merchantPhone;
}
